import 'package:flutter/foundation.dart';

import 'persisted_object.dart';



typedef SubscriptionManager SubscriptionGenerator(OnStreamUpdate onStreamUpdates);
typedef void OnStreamUpdate(List<PersistedObject> snapshot);


abstract class SubscriptionManager {

  void cancel();
}

class SubscriptionManagerImpl implements SubscriptionManager {
  final VoidCallback cancellationFunction;

  SubscriptionManagerImpl(this.cancellationFunction);

  @override
  void cancel() {
    cancellationFunction();
  }
}